<div class="filtros">
  <div class="filtrosPorFecha">
    <p class="nota">
      Nota: Si no selecciona alguna fecha o algún producto los reportes englobarán todas sus ventas, reservas,
      etc. desde los <strong>últimos 3 meses.</strong>
    </p>

    <p-divider></p-divider>

    <div class="filtroPorProducto">
      <label class="label-fw500">Producto</label>
      <p-dropdown [options]="productos" [(ngModel)]="productoSeleccionado" (ngModelChange)="aumentarFiltroProducto()" optionLabel="nombre" optionValue="idProducto"
        [filter]="true" filterPlaceholder="Buscar producto" placeholder="Seleccione un producto" [showClear]="true"></p-dropdown>
    </div>

    <p-divider></p-divider>

    <div class="filtroGeneral">
      <label class="label-fw500">Rango de fechas (general)</label>
      <p-calendar [(ngModel)]="rangoGeneral" (onClose)="cargarReportesGeneral()" selectionMode="range"
        [readonlyInput]="true" class="calendar" [showClear]="true"></p-calendar>
    </div>

    <p-divider></p-divider>

    <div class="filtrosEspecificos">
      <label class="label-fw500">Rango de fechas (específico)</label>
      <div class="filtroEspecifico">
        <label class="label-fw500">Ventas</label>
        <p-calendar [(ngModel)]="rangoVentas" (ngModelChange)="cargarReporteVentas()" selectionMode="range"
          [readonlyInput]="true" [showClear]="true"></p-calendar>
      </div>

      <div class="filtroEspecifico">
        <label class="label-fw500">Inventario</label>
        <p-calendar [(ngModel)]="rangoInventario" (ngModelChange)="cargarReporteInventario()" selectionMode="range"
          [readonlyInput]="true" [showClear]="true"></p-calendar>
      </div>

      <div class="filtroEspecifico">
        <label class="label-fw500">Reservas</label>
        <p-calendar [(ngModel)]="rangoReservas" (ngModelChange)="cargarReporteReservas()" selectionMode="range"
          [readonlyInput]="true" [showClear]="true"></p-calendar>
      </div>

      <div class="filtroEspecifico">
        <label class="label-fw500">Calificación</label>
        <p-calendar [(ngModel)]="rangoCalificacion" (ngModelChange)="cargarReporteCalificacion()" selectionMode="range"
          [readonlyInput]="true" [showClear]="true"></p-calendar>
      </div>
    </div>
  </div>

  <div class="flex gap-3">
    <button pButton type="button" label="Descargar" icon="pi pi-download" class="btn btn-primary" (click)="descargarReporte()"></button>
    <button pButton type="button" label="Imprimir" icon="pi pi-print" class="btn btn-primary" (click)="imprimirReporte()"></button>
    <button pButton type="button" label="Limpiar filtros" icon="pi pi-trash" class="btn btn-primary" (click)="limpiarFiltros()" ></button>
  </div>
</div>

<div #reporte class="reporte">
  <h1>INFORME DEL EMPRENDIMIENTO</h1>
  <p-divider></p-divider>
  <h4>REPORTE DE VENTAS ({{ fechaInicio }} - {{ fechaFin }})</h4>

  <div class="table">
    <div class="titulo">
      <label>VENTAS TOTALES</label>
      <label>VENTAS CADA DÍA</label>
      <label>PRODUCTOS QUE GENERAN MÁS INGRESOS</label>
    </div>
    <div class="contenido">
      <div class="contenido-td">
        <span>Total de ventas: <strong>{{ ventasTotales }}.</strong></span>
        <span>Ventas terminadas: <strong>{{ ventasTerminadas }}.</strong></span>
        <span>Monto recaudado: <strong>{{ gananciasVentaTerminada }}Bs.</strong></span>
        <span>Ventas en proceso: <strong>{{ ventasEnProceso }}.</strong></span>
        <span>Monto por recaudar: <strong>{{ gananciasVentaEnProceso }}Bs.</strong></span>
      </div>
      <div class="contenido-td">
        <span *ngFor="let dia of ventasPorDias; let i = index">
          {{ diasDeLaSemana[i] }}: <strong>{{ dia }} {{ dia === 1 ? 'venta' : 'ventas'}}</strong> - Ganancia total:
          <strong>{{ gananciaPorDias[i] }}Bs.</strong>
        </span>
      </div>
      <div class="contenido-td">
        <span *ngFor="let producto of productosQueGeneranVenta">
          {{ producto.nombre }}: <strong>{{ producto.cantidad }} {{ producto.cantidad === 1 ? 'venta' :
            'ventas'}}</strong> - Ganancia total: <strong>{{ producto.subTotal }}Bs.</strong>
        </span>
      </div>
    </div>
  </div>

  <h4>REPORTE DE RESERVAS ({{ fechaInicio }} - {{ fechaFin }})</h4>
  <div class="table table-reservas">
    <div class="titulo">
      <label>RESERVAS TOTALES</label>
      <label>RESERVAS POR PRODUCTO</label>
    </div>

    <div class="contenido">
      <div class="contenido-td">
        <span>
          Hay <strong>{{ totalReservas }}</strong> {{ totalReservas === 1 ? 'reserva' : 'reservas' }} en total. <br>
        </span>
      </div>
      <div class="contenido-td">
        <span *ngFor="let reserva of reservasTotales">
          {{ reserva.producto }}:
          <strong *ngIf="reserva.reservasPorConfirmar > 0">
            {{ reserva.reservasPorConfirmar }} {{ reserva.reservasPorConfirmar === 1 ? 'reserva' : 'reservas' }} por
            confirmar |
          </strong>
          <strong *ngIf="reserva.reservasConfirmadas > 0">
            {{ reserva.reservasConfirmadas }} {{ reserva.reservasConfirmadas === 1 ? 'reserva' : 'reservas' }}
            confirmadas |
          </strong>
          <strong *ngIf="reserva.reservasRechazadas > 0">
            {{ reserva.reservasRechazadas }} {{ reserva.reservasRechazadas === 1 ? 'reserva' : 'reservas' }} canceladas
            |
          </strong>
          <strong *ngIf="reserva.reservasPorRetirar > 0">
            {{ reserva.reservasPorRetirar }} {{ reserva.reservasPorRetirar === 1 ? 'reserva' : 'reservas' }} terminadas
            |
          </strong>
          <strong *ngIf="reserva.reservasEntregadas > 0">
            {{ reserva.reservasEntregadas }} {{ reserva.reservasEntregadas === 1 ? 'reserva' : 'reservas' }} en proceso
            |
          </strong>
        </span>
      </div>
    </div>
  </div>

  <h4>REPORTE DE CALIFICACIÓN DEL EMPRENDIMIENTO ({{ fechaInicio }} - {{ fechaFin }})</h4>
  <div class="table table-calificacion">
    <div class="titulo">
      <label>CALIFICACIÓN PROMEDIO</label>
      <label>CALIFICACIÓN 5 ESTRELLAS</label>
      <label>CALIFICACIÓN 4 ESTRELLAS</label>
    </div>

    <div class="contenido">
      <div class="contenido-td">
        <span>
          <strong>{{ calificacion }}</strong> puntos de
          <strong>{{ totalCalificaciones }}</strong>
          {{ totalCalificaciones === 1 ? 'calificación' : 'calificaciones' }} recibidas.
        </span>
      </div>
      <div class="contenido-td">
        <span>{{ calificaciones[4] }}</span>
      </div>
      <div class="contenido-td">
        <span>{{ calificaciones[3] }}</span>
      </div>
    </div>

    <div class="titulo">
      <label>CALIFICACIÓN 3 ESTRELLAS</label>
      <label>CALIFICACIÓN 2 ESTRELLAS</label>
      <label>CALIFICACIÓN 1 ESTRELLAS</label>
    </div>
    <div class="contenido">
      <div class="contenido-td">
        <span>{{ calificaciones[2] }}</span>
      </div>
      <div class="contenido-td">
        <span>{{ calificaciones[1] }}</span>
      </div>
      <div class="contenido-td">
        <span>{{ calificaciones[0] }}</span>
      </div>
    </div>
  </div>

  <h4>REPORTE DE INVENTARIO (NO SE APLICAN LOS FILTROS)</h4>
  <div class="table table-inventario">
    <div class="titulo">
      <label>STOCK ACTUAL DE PRODUCTOS</label>
      <label>STOCK MÍNIMO CONFIGURADO</label>
    </div>
    <div class="contenido">
      <div class="contenido-td">
        <span *ngFor="let producto of productosStock">
          {{ producto.nombre }}: <strong>{{ producto.stock }} {{ producto.stock === 1 ? 'unidad' : 'unidades'
            }}.</strong>
        </span>
      </div>

      <div class="contenido-td">
        <span *ngFor="let producto of reponerStock">
          {{ producto.nombre }}: <strong>{{ producto.stock }} {{ producto.stock === 1 ? 'unidad' : 'unidades'
            }}.</strong> <br>
          Stock mínimo programado para la reposición: <strong>{{ producto.stockMinimo }} {{ producto.stockMinimo === 1 ?
            'unidad' : 'unidades' }}.</strong> <br>
          <span *ngIf="producto.stock === 0">Debe reponer {{ producto.stockMinimo }} {{ producto.stockMinimo === 1 ?
            'unidad' : 'unidades' }}.</span>
        </span>
      </div>
    </div>
  </div>
</div>
